<?php

class upload{
    var $file_src_name;
    var $file_src_name_body;
    var $file_src_name_ext;
    var $file_src_mime;
    var $file_src_size;
    var $file_src_error;
    var $file_src_pathname;

    var $file_dst_path;
    var $file_dst_name;
    var $file_dst_name_body;
    var $file_dst_name_ext;
    var $file_dst_pathname;

    var $image_src_type;
    var $image_src_x;
    var $image_src_y;
    var $image_dst_type;
    var $image_dst_x;
    var $image_dst_y;

    var $uploaded;
    var $processed;
    var $error;
    var $log;

    var $file_new_name_body;
    var $file_name_body_add;
    var $file_new_name_ext;
    var $file_overwrite;

    var $file_max_size;

    var $image_resize;
    var $image_convert;

    var $image_x;
    var $image_y;
    var $image_ratio_x;
    var $image_ratio_y;

    function Init() {
        $this->file_new_name_body = "";
        $this->file_name_body_add = "";
        $this->file_new_name_ext  = "";
        $this->file_overwrite     = false;

        $this->file_max_size      = 1000000;

        $this->image_resize       = false;
        $this->image_convert      = "";

        $this->image_x            = 150;
        $this->image_y            = 150;
        $this->image_ratio_x      = false;
        $this->image_ratio_y      = false;
    }

    function Uploadfile($file) {
        $this->file_src_name      = "";
        $this->file_src_name_body = "";
        $this->file_src_name_ext  = "";
        $this->file_src_mime      = "";
        $this->file_src_size      = "";
        $this->file_src_error     = "";
        $this->file_src_pathname  = "";

        $this->file_dst_path      = "";
        $this->file_dst_name      = "";
        $this->file_dst_name_body = "";
        $this->file_dst_name_ext  = "";
        $this->file_dst_pathname  = "";

        $this->image_src_type     = "";
        $this->image_dst_type     = "";
        $this->image_dst_x        = 0;
        $this->image_dst_y        = 0;

        $this->uploaded           = true;
        $this->processed          = true;
        $this->error              = "";
        $this->log                = "";
        $this->Init();

        if (!$file) {
            $this->uploaded = false;
            $this->error = "Fehler beim hochladen. Bitte versuche es nochmal.";
        }
        
        if ($this->uploaded) {
            $this->file_src_error         = $file['error'];
            switch($this->file_src_error) {
                case 0:
                    // all is OK
                    $this->log .= "- Upload abgeschlossen<br>";
                    break;
                case 1:
                    $this->uploaded = false;
                    $this->error = "Fehler beim hochladen. Die Datei berschreitet die upload_max_filesize Gre, angegeben in der php.ini.";
                    break;
                case 2:
                    $this->uploaded = false;
                    $this->error = "Fehler beim hochladen. Die Datei berschreitet die MAX_FILE_SIZE Gre.";
                    break;
                case 3:
                    $this->uploaded = false;
                    $this->error = "Fehler beim hochladen. Die Datei wurde nur teilweise hochgeladen.";
                    break;
                case 4:
                    $this->uploaded = false;
                    $this->error = "Fehler beim hochladen. Es wurde keine Datei hochgeladen.";
                    break;
                default:
                    $this->uploaded = false;
                    $this->error = "Fehler beim hochladen. Unbekannter Fehler.";
            }
        }

        if ($this->uploaded) {
            $this->file_src_pathname   = $file['tmp_name'];
            $this->file_src_name       = $file['name'];
            if ($this->file_src_name == "") {
                $this->uploaded = false;
                $this->error = "Fehler beim hochladen. Bitte versuch es spter nochmal.";
            }
        }

        if ($this->uploaded) {
            $this->log .= "- file name OK<br>";
            $this->file_src_mime          = $file['type'];
            $this->file_src_size          = $file['size'];
            ereg("\.([^\.]*$)", $this->file_src_name, $extension);
            $this->file_src_name_ext      = strtolower($extension[1]);
            $this->file_src_name_body     = substr($this->file_src_name, 0, ((strlen($this->file_src_name) - strlen($this->file_src_name_ext)))-1);

            if ($this->file_src_size > $this->file_max_size ) {
                $this->uploaded = false;
                $this->error = "Datei zu gro.";
            }
        }
        if ($this->uploaded) {
            $this->log .= "- Dateigre OK<br>";
        }

        $this->log .= "- source variables<BR>";
        $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_src_name         : $this->file_src_name<BR>";
        $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_src_name_body    : $this->file_src_name_body<BR>";
        $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_src_name_ext     : $this->file_src_name_ext<BR>";
        $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_src_pathname     : $this->file_src_pathname<BR>";
        $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_src_mime         : $this->file_src_mime<BR>";
        $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_src_size         : $this->file_src_size<BR>";
        $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_src_error        : $this->file_src_error<BR>";
    }

    function Process($server_path){

        $this->log = "";
        $this->error = "";
        $this->processed = true;
        
        if ($this->uploaded){

            $this->file_dst_path = $server_path;

            $this->file_dst_name = $this->file_src_name;
            $this->file_dst_name_body = $this->file_src_name_body;
            $this->file_dst_name_ext = $this->file_src_name_ext;

            if ($this->file_new_name_body != "") { // rename file body
                $this->file_dst_name_body = $this->file_new_name_body;
                $this->log .= "- new file name body : $this->file_new_name_body<br>";
            }
            if ($this->file_new_name_ext != "") { // rename file ext
                $this->file_dst_name_ext  = $this->file_new_name_ext;
                $this->log .= "- new file name ext : $this->file_new_name_ext<br>";
            }
            if ($this->file_name_body_add != "") { // append a bit to the name
                $this->file_dst_name_body  = $this->file_dst_name_body . $this->file_name_body_add;
                $this->log .= "- file name body add : $this->file_name_body_add<br>";
            }

            $this->log .= "- destination variables<BR>";
            $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_dst_path         : $this->file_dst_path<BR>";
            $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_dst_name_body    : $this->file_dst_name_body<BR>";
            $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_dst_name_ext     : $this->file_dst_name_ext<BR>";

            if ($this->image_resize || $this->image_convert != "") {
                if ($this->image_convert=="") {
                    $this->file_dst_name = $this->file_dst_name_body . "." . $this->file_dst_name_ext;
                    $this->log .= "- image operation, keep extension<br>";
                } else {
                    $this->file_dst_name = $this->file_dst_name_body . "." . $this->image_convert;
                    $this->log .= "- image operation, change extension for conversion type<br>";
                }
            } else {
                $this->file_dst_name = $this->file_dst_name_body . "." . $this->file_dst_name_ext;
                $this->log .= "- no image operation, keep extension<br>";
            }
            $this->file_dst_pathname = $this->file_dst_path . $this->file_dst_name;
            $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_dst_name         : $this->file_dst_name<BR>";
            $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;file_dst_pathname     : $this->file_dst_pathname<BR>";

            if ($this->file_overwrite) {
                 $this->log .= "- no overwrite checking<br>";
            } else {
                if (@file_exists($this->file_dst_pathname)) {
                    $this->processed = false;
                    $this->error = "$this->file_dst_name existiert bereits.<br>";
                } else {
                    $this->log .= "- $this->file_dst_name doesn't exist already<br>";
                }
            }
        } else {
                $this->processed = false;
                $this->error = "Upload invalid. Can't carry on a process<br>";
        }

        if (!is_uploaded_file($this->file_src_pathname)) {
            $this->processed = false;
            $this->error = "No correct source file. Can't carry on a process<br>";
        }

        if (!file_exists($this->file_src_pathname)) {
            $this->processed = false;
            $this->error = "No source file. Can't carry on a process<br>";
        }

        if ($this->processed) {
            if ($this->image_resize || $this->image_convert != "") {
                $this->log .= "- image resizing or conversion wanted<br>";
                switch($this->file_src_mime) {
                    case "image/pjpeg":
                    case "image/jpeg":
                    case "image/jpg":
                        $image_src  = @imagecreatefromjpeg($this->file_src_pathname);
                        if (!$image_src) {
                            $this->processed = false;
                            $this->error = "JPEG lesen wird nicht untersttzt";
                        } else {
                            $this->log .= "- source image is JPEG<br>";
                        }
                        break;
                    case "image/png":
                        $image_src  = @imagecreatefrompng($this->file_src_pathname);
                        if (!$image_src) {
                            $this->processed = false;
                            $this->error = "PNG lesen wird nicht untersttzt";
                        } else {
                            $this->log .= "- source image is PNG<br>";
                        }
                        break;
                    case "image/gif":
                        $image_src  = @imagecreatefromgif($this->file_src_pathname);
                        if (!$image_src) {
                            $this->processed = false;
                            $this->error = "GIF lesen wird nicht untersttzt";
                        } else {
                            $this->log .= "- source image is GIF<br>";
                        }
                        break;
                    default:
                        $this->processed = false;
                        $this->error = "Die Datei konnte nicht gelesen werden.";
                }


                if ($this->processed && $image_src) {

                    if ($this->image_resize) {
                        $this->log .= "- resizing...<br>";
                        $this->image_src_x = imagesx($image_src);
                        $this->image_src_y = imagesy($image_src);

                        if ($this->image_ratio_x && $this->image_ratio_y) {
                            $this->processed = false;
                            $this->error = "can't use ratio for x AND y sizes at the same time";
                        }
                        if ($this->processed) {
                            if ($this->image_ratio_x) {
                                $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;calculate x size<br>";
                                $this->image_dst_x = round(($this->image_src_x * $this->image_y) / $this->image_src_y);
                                $this->image_dst_y = $this->image_y;
                            } else if ($this->image_ratio_y) {
                                $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;calculate y size<br>";
                                $this->image_dst_x = $this->image_x;
                                $this->image_dst_y = round(($this->image_src_y * $this->image_x) / $this->image_src_x);
                            } else {
                                $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;use plain sizes<br>";
                                $this->image_dst_x = $this->image_x;
                                $this->image_dst_y = $this->image_y;
                            }
                        }

                        $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;image_src_x y     : $this->image_src_x x $this->image_src_y<BR>";
                        $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;image_dst_x y     : $this->image_dst_x x $this->image_dst_y<BR>";


                        $image_dst = imagecreatetruecolor($this->image_dst_x, $this->image_dst_y);
                        imagecopyresized($image_dst, $image_src, 0, 0, 0, 0, $this->image_dst_x, $this->image_dst_y, $this->image_src_x, $this->image_src_y);
                        $this->log .= "&nbsp;&nbsp;&nbsp;&nbsp;resized image object created<BR>";

                        switch($this->image_convert) {
                            case "jpeg":
                            case "jpg":
                                $result = @imagejpeg ($image_dst, $this->file_dst_pathname);
                                if (!$result) {
                                    $this->processed = false;
                                    $this->error = "JPEG kann nicht erstellt werden";
                                } else {
                                    $this->log .= "- resized JPEG image created.<br>";
                                }
                                break;
                            case "png":
                                $result = @imagepng ($image_dst, $this->file_dst_pathname);
                                if (!$result) {
                                    $this->processed = false;
                                    $this->error = "PNG kann nicht erstellt werden";
                                } else {
                                    $this->log .= "- resized PNG image created.<br>";
                                }
                                break;
                            case "gif":
                                $result = @imagegif ($image_dst, $this->file_dst_pathname);
                                if (!$result) {
                                    $this->processed = false;
                                    $this->error = "GIF kann nicht erstellt werden";
                                } else {
                                    $this->log .= "- resized GIF image created.<br>";
                                }
                                break;
                            default:
                                $this->processed = false;
                                $this->error = "No conversion type defined";
                        }
                    } else {

                        $this->log .= "- converting...<br>";
                        switch($this->image_convert) {
                            case "jpg":
                                $result = @imagejpeg ($image_src, $this->file_dst_pathname);
                                if (!$result) {
                                    $this->processed = false;
                                    $this->error = "JPEG kann nicht erstellt werden";
                                } else {
                                    $this->log .= "- converted JPEG image created.<br>";
                                }
                                break;
                            case "png":
                                $result = @imagepng ($image_src, $this->file_dst_pathname);
                                if (!$result) {
                                    $this->processed = false;
                                    $this->error = "PNG kann nicht erstellt werden";
                                } else {
                                    $this->log .= "- converted PNG image created.<br>";
                                }
                                break;
                            case "gif":
                                $result = @imagegif ($image_src, $this->file_dst_pathname);
                                if (!$result) {
                                    $this->processed = false;
                                    $this->error = "GIF kann nicht erstellt werden";
                                } else {
                                    $this->log .= "- converted GIF image created.<br>";
                                }
                                break;
                            default:
                                $this->processed = false;
                                $this->error = "No convertion type defined";

                        }
                    }
                }

            } else {
                $this->log .= "- no image processing wanted<br>";

                $result = is_uploaded_file($this->file_src_pathname);
                if ($result) {
                    $result = file_exists($this->file_src_pathname);
                    if ($result) {
                        $result = copy($this->file_src_pathname, $this->file_dst_pathname);
                        if (!$result) {
                            $this->processed = false;
                            $this->error = "Fehler beim Kopieren auf den Server.";
                        }
                    } else {
                        $this->processed = false;
                        $this->error = "Fehler beim Kopieren auf den Server. Quelldatei konnte nicht gefunden werden.";
                    }
                } else {
                    $this->processed = false;
                    $this->error = "Fehler beim Kopieren auf den Server. Quelldatei fehlerhaft.";
                }
            }

        }

        if ($this->processed) {
            $this->log .= "<b>upload OK</b><br>";

        }

        $this->Init();

    }

    function Clean() {
         unlink($this->file_src_pathname);
    }



}